<h1>Список дневных планов</h1>
<input type="button" value="Добавить" class="btn btn-light" (click)="add()" />
<h3>Всего в таблице элементов {{dailyPlanCount}}</h3>
<table *ngIf="tableMode; else create" class="table table-striped">
    <thead>
        <tr>
            <td>Id</td>
            <td>День недели</td>
            <td>Дата</td>
            <td>UserId</td>
        </tr>
    </thead>
    <tbody>
        <tr *ngFor="let i of dailyPlans">
            <ng-template [ngIf]="dailyPlan?.id != i.id" [ngIfElse]="edit">
                <td width="20%">{{i?.id}}</td>
                <td width="20%">{{getDayOfWeek(i?.dayOfWeek)}}</td>
                <td width="20%">{{i?.currentDate}}</td>
                <td width="20%">{{i?.userId}}</td>
                <td width="20%">
                    <button class="btn btn-sm btn-primary" (click)="editDailyPlan(i)">Изменить</button>
                    <button class="btn btn-sm btn-danger" (click)="deleteDailyPlan(i)">Удалить</button>
                </td>
            </ng-template>
        </tr>
    </tbody>
</table>
<ngb-pagination *ngIf="tableMode" class="d-flex justify-content-center" [collectionSize]="dailyPlanCount" [pageSize]="pageSize" [(page)]="page" [boundaryLinks]="true" (pageChange)="onPageChanged($event)"></ngb-pagination>


<!--шаблон для редактирования-->
<ng-template #edit>
    <td>
        <input type="text" disabled [ngModel]="dailyPlan.id" class="form-control" />
    </td>
    <td>
        <input type="text" disabled [ngModel]="getDayOfWeek(dailyPlan.dayOfWeek)" class="form-control" />
    </td>
    <td>
        <div class="input-group">
            <input #currentDate="ngModel" #d="ngbDatepicker" class="form-control" placeholder="yyyy-mm-dd" [(ngModel)]="dailyPlan.currentDate" ngbDatepicker>
            <div class="input-group-append">
                <button class="btn btn-outline-secondary calendar" (click)="d.toggle()" type="button"></button>
            </div>
        </div>
        <div class="alert alert-danger" [hidden]="currentDate.valid || currentDate.pristine">
            Дата должна быть в формате yyyy-mm-dd
        </div>
    </td>
    <td>
        <input #userId="ngModel" required pattern="^[1-9]\d*$" type="text" [(ngModel)]="dailyPlan.userId" class="form-control" />
        <div class="alert alert-danger" [hidden]="userId.valid || userId.pristine">
            Идентификатор пользователя должен быть натуральным числом
        </div>
    </td>
    <td width="20%">
        <input type="button" [disabled]="!currentDate.valid || !userId.valid" value="Сохранить" (click)="updateDailyPlan()" class="btn btn-sm btn-success" />
        <input type="button" value="Отмена" (click)="cancelEditDailyPlan()" class="btn btn-sm btn-warning" />
    </td>
</ng-template>

<!--шаблон для добавления-->
<ng-template #create>
    <div class="form-group">
        <label>Дата</label>
        <div class="input-group">
            <input #currentDate="ngModel" #d="ngbDatepicker" class="form-control" placeholder="yyyy-mm-dd" [(ngModel)]="dailyPlan.currentDate" ngbDatepicker>
            <div class="input-group-append">
                <button class="btn btn-outline-secondary calendar" (click)="d.toggle()" type="button"></button>
            </div>
        </div>
        <div class="alert alert-danger" [hidden]="currentDate.valid || currentDate.pristine">
            Дата должна быть в формате yyyy-mm-dd
        </div>
    </div>
    <div class="form-group">
        <label>Идентификатор пользователя</label>
        <input #userId="ngModel" required pattern="^[1-9]\d*$" type="text" [(ngModel)]="dailyPlan.userId" class="form-control" />
        <div class="alert alert-danger" [hidden]="userId.valid || userId.pristine">
            Идентификатор пользователя должен быть натуральным числом
        </div>
    </div>
    <div>
        <input type="button" [disabled]="!userId.valid || !currentDate.valid" value="Сохранить" (click)="createDailyPlan()" class="btn btn-success" />
        <input type="button" value="Отмена" (click)="cancelAddDailyPlan()" class="btn btn-warning" />
    </div>
</ng-template>